=== debian/changelog ===
suitesparse (1:5.12.0+dfsg-2) unstable; urgency=medium

  * texlive-2022.patch: new patch, fixes FTBFS against TeX Live 2022
    (Closes: #1013618)
  * Bump S-V to 4.6.1

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 27 Jun 2022 13:43:38 +0200

suitesparse (1:5.12.0+dfsg-1) unstable; urgency=medium

  * New upstream version 5.12.0+dfsg
  * d/copyright: reflect upstream changes

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 20 Apr 2022 11:09:24 +0200

suitesparse (1:5.11.0+dfsg-1) unstable; urgency=medium

  * d/copyright: reflect upstream changes
  * New upstream version 5.11.0+dfsg
  * Trim trailing whitespace.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 17 Mar 2022 14:39:03 +0100
